<?php
// This file is called on plugin activation

// Create table to record results (if it doesn't already exist)
global $wpdb;
$table_name = $wpdb->prefix . 'eci_results';
if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
	// create the table if it doesn't already exist
	$sql = "CREATE TABLE " . $table_name . " (
		id BIGINT(20) NOT NULL AUTO_INCREMENT,
		postid BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
		user_name VARCHAR(255) NOT NULL,
		user_email VARCHAR(255) NOT NULL,
		user_url VARCHAR(255) NOT NULL,
		user_ip VARCHAR(16) NOT NULL,
		date DATETIME NOT NULL,
		time VARCHAR(8) NOT NULL,
		UNIQUE KEY id (id)
	);";
	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	dbDelta($sql);
}

// get current options, assign defaults if not already set, update the options db
$eci_options = get_option('eci_options');
if (!isset($eci_options['users_to_show'])) $eci_options['users_to_show'] = 5;
if (!isset($eci_options['nofollow'])) $eci_options['nofollow'] = 1;
if (!isset($eci_options['custom_message'])) $eci_options['custom_message'] = '';
update_option('eci_options', $eci_options);

?>