<?php
// This file is called on Admin pages

// call the function that creates the Admin page
if (function_exists('add_options_page')) {
	add_options_page('Eclipse Crossword Integration Settings', 'Eclipse Crossword Integration', 10, basename(__FILE__), 'eci_admin_page');
}

// ****** START FUNCTION: ECI_ADMIN_PAGE - CREATE ADMIN PAGE ******
function eci_admin_page(){

	// if not WordPress 2.8 and above, tell them it's required
	if (!function_exists('esc_html')) { 			
		echo '<div id="message" class="updated fade"><p><strong>WordPress 2.8 or above required</strong></p></div>';
		return;
	}
	
	// show admin page (drop out of php to do this)
	?>
	<div class="wrap">
		<h2>Eclipse Crossword Integration Settings</h2>
		<div id="poststuff">

		<p>
		<a <?php if (!stristr($_SERVER['REQUEST_URI'],'&')) echo 'style="color:#999" ';?>href="options-general.php?page=eclipse-crossword-admin.php">General Settings</a> | 
		<a <?php if (isset($_GET['user_times'])) echo 'style="color:#999" ';?>href="options-general.php?page=eclipse-crossword-admin.php&user_times=1">User Times Control Panel</a>
		</p>

		<?php
		// Check which page we're on and call function to create it
		if (isset($_GET['user_times'])) {
			eci_user_times_admin_page(htmlentities($_GET['user_times']));
		}
		else {
			eci_general_settings_page();
		}
		?>
			<!-- Thank You Section -->
			<div class="stuffbox">
				<h3>Thank You</h3>
				<div class="inside">
					<p>Thank you for using the Eclipse Crossword Integration plugin. If you like this plugin, you may like to:</p>
					<ul style="font-size:1em; margin:12px 40px; list-style:disc">
					<li>Link to the <a href="http://www.scratch99.com/wordpress-plugin-eclipse-crossword-integration/">plugin's home page</a> so others can find out about it</li>
					<li>Support ongoing development by <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&business=sjc@scratch99.com&currency_code=&amount=&return=&item_name=Buy+Me+A+Drink">making a donation</a></li>
					<li>Check out <a href="http://www.scratch99.com/wordpress-plugins-by-stephen-cronin/">my other WordPress plugins</a></li>
					<li><a href="http://www.scratch99.com/feed/">Subscribe to my feed</a> to learn about new plugins I'm working on</li>
					</ul>
					<p>I also provide <a href="http://www.scratch99.com/services/">wordpress and web development services</a>.
					<p><small>Copyright 2009 by Stephen Cronin. Released under the GNU General Public License (version 2 or later).</small></p>
				</div> <!-- class="inside" -->
			</div> <!-- class="stuffbox" -->
		
		</div> <!-- end id="poststuff" -->
	</div> <!-- end class="wrap" -->

<?php
}
// ****** END FUNCTION: ECI_ADMIN_PAGE - CREATE ADMIN PAGE ******


// ****** START FUNCTION: ECI_GENERAL_SETTINGS_PAGE - GENERAL SETTINGS PAGE ******
function eci_general_settings_page() {
	
	$eci_options = get_option('eci_options');

	// Post the update settings form
	if (isset($_POST['eci_options_submit']) && check_admin_referer('eclipse_crossword_admin_page_submit')) {
		$eci_options['users_to_show'] = absint($_POST['eci_users_to_show']);
		
//		echo "damn : ".$eci_options['users_to_show'];
		
		$eci_options['nofollow'] = absint($_POST['eci_nofollow']);
		$eci_options['custom_message'] = esc_html($_POST['eci_custom_message']);
		update_option('eci_options', $eci_options);
		echo '<div id="message" class="updated fade"><p><strong>';
		_e('Options saved.'); 	// really need to language-ify the rest as well
		echo '</strong></p></div>';
	}

	// Post the uninstall form
	if (isset($_POST['eci_uninstall']) && check_admin_referer('eclipse_crossword_uninstall_and_deacctivate_submit')) {
		global $wpdb;
		$table_name = $wpdb->prefix . 'eci_results';
		if($wpdb->get_var("show tables like '$table_name'") == $table_name) {
			$insert = "DROP TABLE " . $table_name;
			$results = $wpdb->query( $insert );
		}
		if (delete_option('eci_options')) {
			$active_plugins = get_settings('active_plugins');
			array_splice($active_plugins, array_search(plugin_basename(dirname(__FILE__)).'/eclipse-crossword.php',$active_plugins),1);
			update_option('active_plugins', $active_plugins);
			echo '
				<script type="text/javascript">
				window.location = "plugins.php?deactivate=true";
				</script>
			';
		}		
		else {
			echo '<div id="message" class="updated fade"><p><strong>An error has occurred while trying to delete the options from database. Please try again.</strong></p></div>';
		}
	}

	// show admin page (drop out of php to do this)
	?>
			<!-- Start General Settings Form (Posts to this page) -->
			<form name="eci_options_form" action="" method="post">
			<?php if (function_exists(wp_nonce_field)) {wp_nonce_field('eclipse_crossword_admin_page_submit'); }?>

			<!-- The General Settings section of the option page -->
			<div class="stuffbox">
				<h3>General Settings</h3>
				<div class="inside">

					<h4>Number Of Top Times To Show</h4>
					<p><input type="text" size="1" name="eci_users_to_show" id="eci_users_to_show" value="<?php echo $eci_options['users_to_show'];?>" /> The number of entries shown in the Top Times section for each crossword.</p>						

					<h4>Nofollow Top Times Links</h4>
					<p><input type="checkbox" name="eci_nofollow" id="eci_nofollow" value="1" <?php if ($eci_options['nofollow']==1) {echo 'checked="checked"';}?> /> Whether the links to users' websites (in the Top Times) are nofollow or not. Select nofollow if you are worried about being targeted by spammers.</p>
					
					<h4>Message To Users When Saving Top Times</h4>
					<p>When a user saves their time, they will see this message. Use this to outline any linking policy you may have.</p>
					<textarea style="width: 90%; max-width:450px; height: 120px;" id="eci_custom_message" name="eci_custom_message"><?php echo stripslashes($eci_options['custom_message']); ?></textarea>
					
					<!-- Show Bottom Update Button -->
					<div class="submit">
					<input type="submit" name="eci_options_submit" value="<?php _e('Update Options &raquo;') ?>"/>
					</div>
					
				</div> <!-- class="inside" -->
			</div> <!-- class="stuffbox" -->
			</form>
			<!-- End General Settings Form (Posts to this page) -->

			<!-- Start Uninstall Form (Posts to this page) -->
			<form name="eci_uninstall_form" action="" method="post">
			<?php if (function_exists(wp_nonce_field)) {wp_nonce_field('eclipse_crossword_uninstall_and_deacctivate_submit'); }?>
			<!-- The Uninstall section of the option page -->
			<div class="stuffbox">
				<h3>Uninstall</h3>
				<div class="inside">
					<p>Choose this option to uninstall the plugin. Any database tables and options created by this plugin will be removed and the plugin will be deactivated. Use this only if you are not planning to use the plugin again in future. If you are likely to use the plugin again, please deactivate the plugin from the <a href="plugins.php">Plugins page</a> and your settings will be maintained.</p>
					<p><strong>WARNING: All settings and log data will be lost. This cannot be undone!</strong></p>

					<!-- Show Bottom Update Button -->
					<div class="submit">
					<input type="submit" name="eci_uninstall" value="<?php _e('Uninstall &raquo;') ?>"/>
					</div>
				
				</div> <!-- class="inside" -->
			</div> <!-- class="stuffbox" -->
			</form>
			<!-- End Uninstall Form -->
			
	<?php
}
// ****** END FUNCTION: ECI_GENERAL_SETTINGS_PAGE - GENERAL SETTINGS PAGE ********


// ****** START FUNCTION: ECI_USER_TIMES_ADMIN_PAGE - USER TIMES ADMIN PAGE ******
function eci_user_times_admin_page($page_number) {
	// grab global variables and table names used throughout this function
	global $wpdb; 
	$table_name = $wpdb->prefix . 'eci_results';
	
	if ($wpdb->get_var("show tables like '$table_name'") == $table_name) {
		
		// Post form
		if (isset($_POST['eci_user_times_admin_submit']) && check_admin_referer('eci_user_times_admin_submit_random_string')) {
			$eci_approval_array = explode(',',trim(htmlentities($_POST['eci_approval_array'])));
			foreach ($eci_approval_array as $value) {
				if (trim(htmlentities($_POST['eci-reject'.$value])) == 'true') {				
					$insert = "DELETE FROM $table_name WHERE id = '$value'";
					$results = $wpdb->query( $insert );
				}
			}
		}

		// set some variables we'll need for paging
		$offset = ($page_number-1)*20;
		$total = $wpdb->get_var("SELECT COUNT(*) FROM $table_name");
		$no_of_pages = ceil($total / 20);

		// get array of user times
		$eci_user_times = $wpdb->get_results("SELECT * FROM $table_name LIMIT $offset, 20", ARRAY_A);  
		// only proceed if there are some results
		if (count($eci_user_times) == 0) {
			echo '<div id="message" class="updated fade"><p><strong>ERROR: There are no user times yet</strong></p></div>';
			return;
		}
	}
	else {
		echo '<div id="message" class="updated fade"><p><strong>ERROR: Database table not found.</strong></p></div>';
		return;
	}
?>
	<!-- The User Times Control Panel section of the page -->
	<div class="stuffbox">
		<h3>User Times Control Panel</h3>
		<div class="inside">
			<!-- Start Form (posts to this page) -->
			<form name="eci_user_times_admin_form" action="" method="post">
			<?php if (function_exists(wp_nonce_field)) {wp_nonce_field('eci_user_times_admin_submit_random_string'); }?>

			<!-- Show Top Update Button -->
			<div style="float:right; margin-top:0;" class="submit">
			<input type="submit" name="eci_user_times_admin_submit" value="<?php _e('Delete &raquo;') ?>"/>
			</div>
			<p>Select any user times you want to delete, then press Delete.</p>

			<?php
			// paging
			echo '<p>Showing records '. ($offset+1) . ' to ';
			if ($page_number == $no_of_pages && $total % 20 != 0) {
				echo $offset+($total % 20);
			}
			else {
				echo $offset + 20;
			}
			echo " of $total. ";
			echo eci_paging($total,$page_number,$no_of_pages) . '</p><div style="clear:both"></div>';

			// loop through to create list of the user's posts etc.
			echo "\n\t\t\t<ul>";
			foreach ($eci_user_times as $key => $value) {
			?>
			
			<li style="padding: .6em; margin: 0 0 0 .8em; max-width:1276px;<?php if (($key % 2) == 0) echo ' background:#eee;'; ?>">
			<input type="checkbox" id="eci-reject<?php echo $value['id']; ?>" name="eci-reject<?php echo $value['id']; ?>" value="true" />
			<?php echo $value['user_name'] . ' (IP:' . $value['user_ip'] . ') linked to <a href="' . $value['user_url'] . '" target="_blank">' . $value['user_url'] . '</a> on <a href="'. get_permalink($value['postid']) .'">'. get_the_title($value['postid']) .'</a>';?>
			</li>

			<?php
			}
			echo "\n\t\t\t</ul>\n\t\t\t".'<input type="hidden" name="eci_approval_array" id="eci_approval_array" value="';
			$i = 1;
			foreach ($eci_user_times as $key => $value) {
				echo $value['id'];
				if ($i != count($eci_user_times)) {
					echo ',';	
				}
			$i++;	
			}
			echo '" />';
			?>

			<!-- Show Bottom Update Button -->
			<div style="float:right" class="submit">
			<input type="submit" name="eci_user_times_admin_submit" value="<?php _e('Delete &raquo;') ?>"/>
			</div>
			<div style="clear:both"></div>
			</form>
			
			<?php
			// paging
			echo '<p>Showing records '. ($offset+1) . ' to ';
			if ($page_number == $no_of_pages && $total % 20 != 0) {
				echo $offset+($total % 20);
			}
			else {
				echo $offset + 20;
			}
			echo " of $total. ";
			echo eci_paging($total,$page_number,$no_of_pages) . '</p><div style="clear:both"></div>';
			?>
		</div> <!-- end class="inside" -->
	</div> <!-- end class="stuffbox" -->	
<?php
}
// ****** END FUNCTION: ECI_USER_TIMES_ADMIN_PAGE - USER TIMES ADMIN PAGE ********


// ****** START FUNCTION: ECI_PAGING - CREATE PAGING ******
function eci_paging($total,$page_number,$no_of_pages) {
	// if there is only 1 page, return nothing
	if ($no_of_pages == 1) {
		return '';
	}
	
	// initialise the variable we'll return at the end
	$paging = 'Page: ';
	
	// work out the start page (this is so we can add .... where approprite)
	if ($page_number <= 4) {
		$start_page = 4;
	} 
	elseif ($page_number >= $no_of_pages-6){
		$start_page = $no_of_pages-6;
	} 
	else {
		$start_page = $page_number;
	}
	
	// show page 1 (but no link if we're on it)
	if ($page_number != 1) {
		$paging .= '<a href="options-general.php?page=eclipse-crossword-admin.php&user_times=1">1</a>'."\n";
	} 
	else {
		$paging .= "1\n";
	}
	
	// loop through the middle 8 pages, separating them with .... or | as appropriate
	for ($i = $start_page-2; $i <= $start_page+5 && $i <= $no_of_pages - 1; $i++) {
		//if ($i <= $page_number) {
			if ($start_page > 4 && $i ==$start_page-2){
				$paging .= ' .... ';
			} 
			else {
				$paging .= ' | ';
			}
			if ($page_number != $i) {	
				$paging .= '<a href="options-general.php?page=eclipse-crossword-admin.php&user_times='.$i.'">'.$i.'</a>'."\n";
			} 
			else {
				$paging .= $i."\n";
			}
		//}
	}
	
	// show last page, with appropriate separator preceding it
	if ($no_of_pages > 1) {
		if ($start_page < $no_of_pages-6 && $no_of_pages > 10){
			$paging .= ' .... ';
		}
		else {
			$paging .= ' | ';
		}
		if ($page_number != $no_of_pages) {
			$paging .= '<a href="options-general.php?page=eclipse-crossword-admin.php&user_times='.$no_of_pages.'">'.$no_of_pages.'</a>'."\n";
		} 
		else {
			$paging .= $no_of_pages."\n";
		}
	}
	// return resulting string
	return $paging;
}
// ****** END FUNCTION: ECI_PAGING - CREATE PAGING ******

?>