<?php
// This file is called when shortcode is detected

// Set some variables that we'll need
$eci_options = get_option('eci_options');
$eci_user_name = '';
$eci_user_email = '';
$eci_user_url = '';		
global $wpdb,$post;
$table_name = $wpdb->prefix . 'eci_results';
$eci_post_id = $post->ID;
$eci_user_time='';		

// post form
if (isset($_POST['eci_submit_time']) && check_admin_referer('eci_submit_time_submit_random_string')) {
	$eci_error = '';
	// we won't post if the error field has anything in it, so run through some checks and grab post data
	if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
		$eci_error = 'ERROR: Database connection not available. Please try again later. If problem persists, please contact the site owner.';
	}
	if (function_exists('esc_html')) { 			// only posts with WordPress 2.8 and above
		if (esc_html($_POST['eci_user_name']) != '') {
			$eci_user_name = esc_html($_POST['eci_user_name']);
		}			
		else {
			$eci_error = 'ERROR: You must enter your name.';
		}
	}
	else {
		$eci_error = 'ERROR: Eclipse Crossword Integration does not work with this version of WordPress.';
	} 
	if (is_email($_POST['eci_user_email'])) {
		$eci_user_email = $_POST['eci_user_email'];
	}
	else {
		$eci_error = 'ERROR: You must enter a valid email address.';
	}
	$eci_user_url = apply_filters('pre_comment_author_url', trim($_POST['eci_user_url']));
	$eci_user_IP = addslashes($_SERVER['REMOTE_ADDR']);
	if (esc_html($_POST['eci_time']) != '' || esc_html($_POST['eci_time']) != '0:00:00' ) {
		$eci_user_time = esc_html($_POST['eci_time']);
	}			
	else {
		$eci_error = 'ERROR: No time recorded';
	}

	// check whether this user has posted this time, which would most likely be a duplicate submit
	$eci_this_time_posted = $wpdb->get_var("SELECT COUNT(*) FROM $table_name WHERE user_email = '$eci_user_email' AND time = '$eci_user_time'");
	if ($eci_this_time_posted > 0) {
		$eci_error = 'ERROR: You have already posted an entry with this time.';
	}

	// save only if we haven't had an error
	if ($eci_error != '') {
		echo '<p id="eci-error">'.$eci_error.'</p>';			
	}
	else {
		$wpdb->insert($table_name, array('postid'=>$eci_post_id, 'user_name'=>$eci_user_name, 'user_email'=>$eci_user_email, 'user_url'=>$eci_user_url, 'user_ip'=>$eci_user_IP, 'date'=>date("Y-m-d H:i:s"), 'time'=>$eci_user_time), array('%d','%s','%s','%s','%s','%s','%s'));
	}
}

// read file containing the crossword
$url = $values['url'];
$result = wp_remote_retrieve_body(wp_remote_get($url));

// strip out everything except what we want
$start = strpos($result,'<div id="waitmessage"');
$end = strpos($result,'</body>');
$body = substr($result,$start,$end-$start);

// move message section to the top.
$start = strpos($body,'<td valign="top"');
$end = strpos($body,'</td></tr></table>')+5;
$welcome_message = substr($body,$start,$end-$start);
$body = str_replace($welcome_message, '',$body);
$body = str_replace('<table cellpadding="0" cellspacing="0" border="0"><tr>','<table cellpadding="0" cellspacing="0" border="0"><tr>'.$welcome_message.'</tr><tr></tr><td>&nbsp;</td><tr>',$body);

// add call to the eciSwitchKeys function
$body = str_replace('CellAt(x + i, y).className = CellAt(x + i, y).className.replace(IsSelected ? "_unsel" : "_sel", IsSelected ? "_sel" : "_unsel");', '{
	CellAt(x + i, y).className = CellAt(x + i, y).className.replace(IsSelected ? "_unsel" : "_sel", IsSelected ? "_sel" : "_unsel");
	eciSwitchKeys(CellAt(x + i , y),IsSelected);
}',$body);
$body = str_replace('CellAt(x, y + i).className = CellAt(x, y + i).className.replace(IsSelected ? "_unsel" : "_sel", IsSelected ? "_sel" : "_unsel");', '{
	CellAt(x, y + i).className = CellAt(x, y + i).className.replace(IsSelected ? "_unsel" : "_sel", IsSelected ? "_sel" : "_unsel");
	eciSwitchKeys(CellAt(x,  y + i),IsSelected);
}',$body);

// add link to plugin home page
$body = str_replace("from Green Eclipse&mdash;it's free!", "from Green Eclipse&mdash;it's free!<br/>WordPress Integration by <a href=\"http://www.scratch99.com/wordpress-plugin-eclipse-crossword-integration\">Eclipse Crossword Integration</a>.",$body);
$body = str_replace("EclipseCrossword</a> &copy; 2000-2007", "EclipseCrossword</a> &copy; 2000-2007<br/>WordPress Integration by <a href=\"http://www.scratch99.com/wordpress-plugin-eclipse-crossword-integration\">Eclipse Crossword Integration</a><br/>",$body);

// add timer
$body = str_replace('<div class="ecw-copyright">', '<div class="ecw-copyright"><span id="eci-clock">0:00:00</span>',$body);

// start timer
$body = str_replace('var CrosswordFinished, Initialized;', "var CrosswordFinished, Initialized;\n var eciStarted = 0;",$body);

// stop timer
$body = str_replace('document.getElementById("congratulations").style.display = "block";', "eciStartStop();\n".'document.getElementById("congratulations").style.display = "block";',$body);

// add form to save time
global $user_ID;
$eci_user_info = get_userdata($user_ID);
if (isset($eci_user_info->display_name) && $eci_user_name == '') {
	$eci_user_name = $eci_user_info->display_name;
}
if (isset($eci_user_info->user_email) && $eci_user_email == '') {
	$eci_user_email = $eci_user_info->user_email;
}
if (isset($eci_user_info->user_url) && $eci_user_url == '') {
	$eci_user_url = $eci_user_info->user_url;
}
$body = str_replace('crossword puzzle</a>.', 'crossword puzzle</a>. Record your time (xx:xx) - the top '. $eci_options['users_to_show'] .' times are listed on this post:
</p>
	<form name="eci_submit_time" action="" method="post">
	' . wp_nonce_field('eci_submit_time_submit_random_string') . '
	<p>
	<div id="eci-input">
	Name: <br/><input type="text" size="30" name="eci_user_name" id="eci_user_name" value="'. $eci_user_name .'" /><br/>
	Email: <small>(Required - not shown)</small><br/><input type="text" size="30" name="eci_user_email" id="eci_user_email" value="'. $eci_user_email .'" /><br/>
	Website: <br/><input type="text" size="30" name="eci_user_url" id="eci_user_url" value="'. $eci_user_url .'" /><br/>
	<input type="submit" name="eci_submit_time" value="Save" />
	</div>
	'. stripslashes($eci_options['custom_message']) .'
	<input type="hidden" name="eci_time">
	</form>
',$body);

// strip out inline style that hides the link on pages with black text.
$body = str_replace(' style="color: black; text-decoration:none;"', '', $body);

// get the clues
$start = strpos($body, 'Clue = new Array(')+18;
$end = strpos($body, ');', $start);
$question_string = substr($body,$start,$end-$start);
//$question_string = str_replace('"', '', $question_string);
$question_array = explode('",' , $question_string);

// work out if Across or Down
$start = strpos($result,'LastHorizontalWord = ') + 21;
$end = strpos($result, ';', $start);
$last_across = trim(substr($result,$start,$end-$start));

// work out how many words
$start = strpos($result,'Words = ') + 8;
$end = strpos($result, ';', $start);
$num_of_words = trim(substr($result,$start,$end-$start));

// append them to the end of the body
$body .= "\n<h2>Questions</h2>\n<h3>Across</h3>\n<ul>\n";
$i = 0;
foreach ($question_array as $value) {
	$body .= '<li class="eci-list">' . ($i + 1) . '. ' . str_replace('"', '', stripslashes($value)) . "</li>\n";			
	if ($i == $last_across) {
		$body .= "</ul>\n<h3>Down</h3>\n<ul>\n";
	}
	$i++;
}
$body .= "</ul>\n";

// Add top X users to body
$body .= '<h3>Top Times</h3>';
$top_x_array = $wpdb->get_results("SELECT user_name, user_url, date, time FROM $table_name WHERE postid = '$eci_post_id' ORDER BY time", ARRAY_A);
if (count($top_x_array) > 0) {
	$body .= "\n<ol>\n";
	foreach ($top_x_array as $value) {
		$body .= '<li>Time: <strong>' . $value['time'] . '</strong> by <a href="' . $value['user_url'] .'" target="_blank"';
		if ($eci_options['nofollow'] == 1) {
			$body .= ' rel="nofollow"';
		}
		$body .= '>' . $value['user_name']. '</a> on ' . substr($value['date'],0,10) . "</li>\n";
	}		
	$body .= "</ol>\n";
}
else {
	$body .= '<ul><li>No Times Recorded Yet</li></ul>';
}

// call JavaScript function to draw the numbers in
$body .= '<script type="text/javascript">eciDrawNumbers();</script>'."\n";		

?>