<?php
/*
Plugin Name: Eclipse Crossword Integration
Plugin URI: http://www.scratch99.com/wordpress-plugin-eclipse-crossword-integration/
Description: Allows crosswords created via the Eclipse Crossword software (www.eclipsecrossword.com) to be published via WordPress.
Version: 1.01
Date: 18 December 2009
Author: Stephen Cronin
Author URI: http://www.scratch99.com/

   Copyright 2009  Stephen Cronin  (email : sjc@scratch99.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// ****** SETUP ACTIONS, FILTERS AND SHORTCODES ******
add_action('activate_' . dirname(plugin_basename(__FILE__)) . '/' . basename(__FILE__), 'eci_activate');
add_action('admin_menu', 'eci_admin');
add_action('wp_print_styles', 'eci_add_stylesheet');
add_shortcode('eclipse-crossword', 'eci_shortcode');
// **************************************************

// ****** START FUNCTION: ECI_ACTIVATE - CREATE OPTIONS ON ACTIVATION ******
// in separate file so it's not loaded into memory unless necessary
function eci_activate() {
	require_once('eclipse-crossword-activate.php');
}
// ***********************************************************************

// ****** START FUNCTION: ECI_ADMIN - ADD ADMIN PAGEs ******
// in separate file so it's not loaded into memory unless necessary
function eci_admin() {
	require_once('eclipse-crossword-admin.php');
}
// *******************************************************

// ****** START FUNCTION: ECI_ADD_STYLESHEET - ENQUE CSS FILE ******
function eci_add_stylesheet() {
	global $post;
	$content = $post->post_content;
	// only call them if the post includes the tag
	if (stristr($content,'eclipse-crossword url=')) {
		$plugin_name = dirname(plugin_basename(__FILE__));
		wp_enqueue_style('eclipse-crossword', plugins_url($plugin_name.'/includes/eci.css'));
		wp_enqueue_script('eclipse-crossword', plugins_url($plugin_name.'/includes/eci.js'));
	}
}
// ***************************************************************

// ****** START FUNCTION: ECI_SHORTCODE - ADD CROSSWORD ******
function eci_shortcode($params) {
	$values = shortcode_atts(array('url' => ''), $params);
	$body = '';
	if ($values['url'] != ''){
		// in separate file so it's not loaded into memory unless necessary
		require_once('eclipse-crossword-shortcode.php');
	}
	return $body;	
}
// ***********************************************************

?>